/*

   +---------------+    
   | ImageFile     |    
   +---------------+    
   | String name   |     
   | int    width  |      
   | int    height |      
   | String kind   |      
   +---------------+    

 */  

//to represent an image file
public class ImageFile implements ISame {
  public String name;
  public int width;
  public int height;
  public String kind;
  
  public ImageFile(String name, int width, int height, String kind){
    this.name = name;
    this.width = width;
    this.height = height;
    this.kind = kind;
  }
  
  /* TEMPLATE:
  ... this.name ...
  ... this.name   = ??? 
  ... this.width ...
  ... this.width  =  ???
  ... this.height ...
  ... this.height = ???
  ... this.kind ... 
  ... this.kind   = ???
  */
  
  // design the method crop...
  public void crop(int w, int h){
    String s = "Do nothing.";
  }
  
  // design the method changeName ...
  
  // is this imagefile the same as the given one?
  public boolean same(ISame obj){
    if (obj instanceof ImageFile)
      return this.sameImageFile((ImageFile)obj);
    else
      return false;
  }
  
  // is this imagefile the same as the given one?
  public boolean sameImageFile(ImageFile that){
    return this.name.equals(that.name) &&
           this.width == that.width &&
           this.height == that.height &&
           this.kind.equals(that.kind);
  }
  
  // represent this data as String
  public String toString(){
    return "new ImageFile(\n" +
           "   name = " + name + ",\n" +
           "   width = " + width + ",\n" +
           "   height = " + height + ",\n" +
           "   kind = " + kind + ")\n";
  }
}