  public class Examples {
    
    // sample data to be used for all tests
    public ImageFile pic1 = new ImageFile("dog", 300, 200, "jpg");
    public ImageFile pic2 = new ImageFile("cat", 200, 200, "png");
    public ImageFile pic3 = new ImageFile("bird", 250, 200, "jpg");
    public ImageFile pic4 = new ImageFile("horse", 300, 300, "giff");
    public ImageFile pic5 = new ImageFile("goat", 100, 200, "giff");
    public ImageFile pic6 = new ImageFile("cow", 150, 200, "jpg");
    public ImageFile pic7 = new ImageFile("snake", 200, 300, "jpg");
    
    //empty list
    AList mt= new MTList();

    // picture list -- all pictures
    AList piclistall = new ConsList(pic1, 
        new ConsList(pic2,
            new ConsList(pic3, 
                new ConsList(pic4, 
                    new ConsList(pic5, 
                        new ConsList(pic6, 
                            new ConsList(pic7, mt))))))); 
      
  // picture list - short names (less than 4 characters)
  AList piclistshortnames = new ConsList(pic1, 
      new ConsList(pic2, 
          new ConsList(pic6, mt))); 
  
  // picture list - small size (< 40000)
  AList piclistsmall = new ConsList(pic5, 
      new ConsList(pic6, mt));
  
  // picture list - small size (< 40000)
  AList piclistsmall2 = new ConsList(pic5, 
      new ConsList(pic6, mt));

  // picture list -- large pictures
  AList piclistlarge = new ConsList(pic1, 
      new ConsList(pic2,
          new ConsList(pic3,mt))); 

  // rest all data to the original values before running a test
    public void resetData(){
      this.pic1 = new ImageFile("dog", 300, 200, "jpg");
      this.pic2 = new ImageFile("cat", 200, 200, "png");
      this.pic3 = new ImageFile("bird", 250, 200, "jpg");
      this.pic4 = new ImageFile("horse", 300, 300, "giff");
      this.pic5 = new ImageFile("goat", 100, 200, "giff");
      this.pic6 = new ImageFile("cow", 150, 200, "jpg");
      this.pic7 = new ImageFile("snake", 200, 300, "jpg");
      
      //empty list
      this.mt= new MTList();
  
      // picture list -- all pictures
      this.piclistall = new ConsList(pic1, 
          new ConsList(pic2,
              new ConsList(pic3, 
                  new ConsList(pic4, 
                      new ConsList(pic5, 
                          new ConsList(pic6, 
                              new ConsList(pic7, mt))))))); 
        
    // picture list - short names (less than 4 characters)
    this.piclistshortnames = new ConsList(pic1, 
        new ConsList(pic2, 
            new ConsList(pic6, mt))); 
    
    // picture list - small size (< 40000)
    this.piclistsmall = new ConsList(pic5, 
        new ConsList(pic6, mt));
    }
 
 
    // the test harness for all tests
    public TestHarness th = new TestHarness("Test ImageFile methods ");
    
    // run the test suite for the crop method 
    public void testCropMethod() {
      // SETUP (for both tests)
      this.resetData();
      
      // APPLY THE METHOD
      // pic1.crop(...);
  
      // TEST THE EFFECT
      // th.test("crop1: ", pic1, new ImageFile(...));
      
      // APPLY THE METHOD
      // pic2.crop(...);
  
      // TEST THE EFFECT
      // th.test("crop2: ", pic2, new ImageFile(...));
    }
    
      // hook to the outside world
    public static void main(String argv[]){
      Examples e = new Examples();
      
      // show the data used in the tests
      // ... included only for illustration --- not needed
      System.out.println("" + e.pic1);
      System.out.println("" + e.pic2);
      
      //run all tests;
      e.testCropMethod();
      // e.testChangeNameMethod();
 
      // report the test results
      e.th.testReport();
      e.th.fullTestReport();
    }
    
  
  }